#include "PolyRegression.h"

PolyRegression::PolyRegression(DataTable TheTable, 
					int YColumn, int XColumn, int DColumn, int degree) {
	int d, dd, N;	// local loop control variables

	N = TheTable.N;			// TheTable knows how large N is
	X.ReSize(N,(degree+1));	// must resize the matrices
	D.ReSize(N);			// which have been defined with no sizes
	Y.ReSize(N);			// in the constructor
	beta.ReSize(degree+1);
	
	X.Column(1) = 1.0;				// create the first column of the X matrix
	for (d = 1; d <= degree; d++) {
		X.Column(d+1) = TheTable.Data.Column(XColumn); // column 2 is the x variable
		for (dd = 2; dd <= d; dd++) {
			X.Column(d+1) = SP(X.Column(d+1), TheTable.Data.Column(XColumn));
		}			// subsequent columns are "powered up"
	}
	Y = TheTable.Data.Column(YColumn);		// Y and D are extracted here from the
	D = (TheTable.Data.Column(DColumn)).AsDiagonal();	// DataTable
	
	beta = ((X.t()*D*X).i()) * (X.t()*D*Y);		// and we compute beta
	
// if one wanted to be able to access values for SE, yhat, and/or residuals
// after constructor call (alone) one would compute those vectors here...	
	
}

PolyRegression::~PolyRegression() {
// null destructor
}

Matrix PolyRegression::VarCov(double sigma2) {
	Matrix V;
	V.ReSize(beta.Nrows(), beta.Nrows());
// V  would be computed here; see homework exercises
	return V;
}