#ifndef _POLY_REGRESSION_CLASS_
#define _POLY_REGRESSION_CLASS_

#include "DataTable.h"

using namespace std;

class PolyRegression {

public:	
	ColumnVector beta;	// beta is public, so it can be used outside
	ColumnVector SE;	// the vectors SE, 
	ColumnVector yhat;	// yhat, and residuals are defined here as public
	ColumnVector residuals;	// but their computation is not implemented
							// see homework exercises
							
// constructor from the DataTable, and columns for Y, X, D, and degree
// in PolyRegression.cp
PolyRegression(DataTable TheTable, 
					int YColumn, int XColumn, int DColumn, int degree);

// destructor is required
~PolyRegression();	// in PolyRegression.cp

// a routine to return the variance-covariance matrix of the coefficients
// is defined here, but not implemented (actually implemented vacuously)
// in PolyRegression.cp; see homework exercises
Matrix VarCov(double sigma2);
// note that this routine has an argument, sigma2,
// which is the error variance that must be computed outside and supplied

private:	// these variables are not available to the outside
	Matrix X;
	DiagonalMatrix D;
	ColumnVector Y;

};

#endif /* _POLY_REGRESSION_CLASS_ */
